/*solveObjLoop.cc
-------------------------------------------
$B%*%V%8%'%/%H4V$N%k!<%W$r2r>C$9$k%W%m%0%i%`(B
-------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char** argv)
{
  // $B0z?t$N?t$N%A%'%C%/(B

  if (argc != 1 && argc != 5) {
    printf("Usage : solveObjLoop pf2FileName");
    printf(" subsystemFileName gcnd_connectFileName\n");
    exit(1);
  }

  char org_pf2_fname[256];      // $BEv3:%0%j%C%I$N2OF;%G!<%?%U%!%$%kL>(B
  char sub_fname[256];          // $BItJ,7O%b%G%k$N2OF;6hJ,@\B3>pJs%U%!%$%kL>(B
  char mod_pf2_fname[256];      // $B=$@5$5$l$?2OF;%G!<%?%U%!%$%kL>(B
  char gcnd_fname[256];			// gcnd $B$,:n@.$7$?%0%j%C%I4V$N@\(B
								// $BB3>u67%U%!%$%kL>(B

  if (argc == 1) {
    printf("# original pf2 file : ");
    scanf("%s", org_pf2_fname);
    printf("# link connection file : ");
    scanf("%s", sub_fname);
	printf("# modified pf2 file : ");
	scanf("%s", mod_pf2_fname);
	printf("# gcnd connection file : ");
	scanf("%s", gcnd_fname);
  }

  else {
    sscanf(argv[1], "%s", org_pf2_fname);
    sscanf(argv[2], "%s", sub_fname);
    sscanf(argv[3], "%s", mod_pf2_fname);
    sscanf(argv[4], "%s", gcnd_fname);
  }

  FILE* fp_org_pf2;     // $BEv3:%0%j%C%I$N2OF;%G!<%?%U%!%$%k(B
  FILE* fp_sub;        // $BItJ,7O%b%G%k$N2OF;6hJ,@\B3>pJs%U%!%$%k(B
  FILE* fp_mod_pf2;    // $B=$@5$5$l$?ItJ,?e7O$N2OF;%G!<%?%U%!%$%k(B
  FILE* fp_gcnd;       // $B%0%j%C%I4V@\B3>u67%U%!%$%k(B
  FILE* fp_work;

  char buf[256];
  char* pbuf;
  int seg_no, sigma_up, mu_up, sigma_down, mu_down;

  //$BItJ,?e7O$4$H$N2OF;6hJ,@\B3>u67%U%!%$%k(B(**.sub)$B$+$i@ZCG$9$Y$-2O(B
  //$BF;6hJ,$NHV9f$rFI$_$H$k!#(B 

  if((fp_sub = fopen(sub_fname, "r")) == NULL){
    printf("Cannot open link connection file.\n");
    exit(1);
  }

  int link_cut[100];   //$B@ZCG$9$Y$-2OF;6hJ,HV9f$rF~$l$F$*$/G[Ns(B
  int a = 0;

  while(fgets(buf, 256, fp_sub) != NULL){
    pbuf = buf;
	if((buf[0] == '#') || (buf[0] == '\n')) continue;
	if(sscanf(pbuf, "%d", &seg_no) != 1){
	  printf("Cannot scan seg_no.\n");
	  exit(1);
    }
	
	while(*pbuf != ':') pbuf++;
	  pbuf++;
	  int flag_bunryuu = 0;
	  int flag_gouryuu = 0;
	
	  if(sscanf(pbuf, "%d", &sigma_up) != 1){
        printf("Cannot scan sigma_up.\n");
		exit(1);
	  }
	  //printf("sigma_up= %d\n", sigma_up);
	  if(sigma_up < 2) continue;
	  else{
        while(*pbuf != ':') pbuf++;
		pbuf++;

		int j;
		int k;
	  
	  	for(j = 0; j < sigma_up; j++){
		  while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
	      if(sscanf(pbuf, "%d", &mu_up) != 1){
			printf("Cannot scan mu_up.\n");
			exit(1);
	      }
		  //printf("mu_up= %d\n", mu_up);
		  while((*pbuf != ' ') && (*pbuf != '\t')) pbuf++; 
		  if(mu_up < 0){
		    // $B>eN.B&$KJ,N.E@$rH/8+(B
			flag_bunryuu = 1;
			break;
		  }
		}
		while(*pbuf != ':') pbuf++;
		pbuf++;
		
			
		if(sscanf(pbuf, "%d", &sigma_down) != 1){
		  printf("Cannot scan sigma_down.\n");
		  exit(1);
    	}  

		if(sigma_down == 1){
			//$B>eN.B&C<E@$,J,N.E@!"2<N.B&C<E@$,(B
			//$B9gN.E@$G$"$k2OF;6hJ,$N0lIt$G$"$k2DG=@-$,$"(B
			//$B$k$N$G8uJd$H$7$F;D$7$F$*$/I,MW$,$"$k!#(B
		  flag_gouryuu = 1;
		}
        else{
		  while(*pbuf != ':') pbuf++;
		  pbuf++;

	  	  for(k = 0; k < sigma_down; k++){
            while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
	    	if(sscanf(pbuf, "%d", &mu_down) != 1){
			  printf("Cannot scan mu_down.\n");
			  exit(1);
			}
			while((*pbuf != ' ') && (*pbuf != '\t')) pbuf++;
	  		if(mu_down > 0){
	      	  // $B2<N.B&$K9gN.E@$rH/8+!#(B
			  flag_gouryuu = 1;
			  break;
			}
          }
	    }	
	  }

	  if((flag_bunryuu == 1) && (flag_gouryuu == 1)){
		  link_cut[a] = seg_no;
		  a = a+1;
	  }
  }

  if((fp_org_pf2 = fopen(org_pf2_fname, "r")) == NULL){
    printf("Cannot open original pf2 file.\n");
    exit(1);
  }

  //$B0J>e$G@ZCG$9$Y$-2OF;6hJ,HV9f$rFI$_$H$C$?!#(B
  //$B0J2<$G$O3F%*%V%8%'%/%H$K$*$$$F@ZCG$9$Y$-2OF;6hJ,$r!"2OF;%G!<%?>e(B
  //$B$G@ZCG$9$k:n6H!"$*$h$S(B gcnd $B$,=PNO$7$?%0%j%C%I4V$N@\B3>u67%U%!(B
  //$B%$%k$K?7$?$J@\B3>pJs$r2C$($k:n6H$r9T$J$&!#(B

  //$B=$@5$7$?2OF;%G!<%?$r!"ET9g>e!"0lC6(B workfile $B$K=PNO$9$k!#(B

  if((fp_work = fopen("workfile", "w")) == NULL){
    printf("Cannot open workfile.\n");
    exit(1);
  }

  if((fp_gcnd = fopen(gcnd_fname, "a")) == NULL){
    printf("Cannot open modified gcnd-connect file.\n");
    exit(1);
  }


  int num_EP;      //$BC<E@$N8D?t(B
  int num_RivSeg;  //$B2OF;6hJ,$N8D?t(B

  char* pbuf2;
  pbuf2 = buf;

  while (fgets(buf, 256, fp_org_pf2) != NULL){
	if (strncmp(buf, "[Number of End Points]", 18) != 0){
	  fprintf(fp_work,"%s",buf);
    }

  //$BC<E@$N8D?t$rFI$_$H$j!"$3$l$K2OF;6hJ,$N@ZCG$K$h$j@8$8$k?7$?$JC<E@$N8D?t$r(B
  //$B2C$($?$b$N$r5-F~$9$k!#(B

	else{
	  while (fgets(buf, 256, fp_org_pf2) != NULL){
		sscanf(buf, "%d", &num_EP);
		fprintf(fp_work,"[Number of End Points]\n");
		fprintf(fp_work,"%d\n",(num_EP + 2*a));
		break;
	  }
	  break;
	}
  }
  while (fgets(buf, 256, fp_org_pf2) != NULL){
	if (strncmp(buf, "[Number of River Segments]", 20) != 0){
	  fprintf(fp_work,"%s",buf);
    }

  //$B2OF;6hJ,$N8D?t$rFI$_$H$j!"$3$l$K2OF;6hJ,$N@ZCG$K$h$j@8$8$k?7$?(B
  //$B$J2OF;6hJ,$N8D?t$r2C$($?$b$N$r5-F~$9$k!#(B

	else{
      while (fgets(buf, 256, fp_org_pf2) != NULL){
		sscanf(pbuf2, "%d", &num_RivSeg);
		fprintf(fp_work,"[Number of River Segments]\n");
		fprintf(fp_work,"%d\n",(num_RivSeg + a));
		break;
	  }
	  break;
	}
  }

  while (fgets(buf, 256, fp_org_pf2) != NULL){
	  if (strncmp(buf, "[Data]", 6) == 0){
		  fprintf(fp_work,"%s",buf);
		  break;
	  }
  }

  int gX;      //$B%0%j%C%I$N(Bx$B:BI8(B
  int gY;      //$B%0%j%C%I$N(By$B:BI8(B
  int EPNo;         //$BC<E@HV9f(B
  int SegNo;   //$B2OF;6hJ,HV9f(B
  int EPinfo;       //$BC<E@>pJs(B
  double Lx;        //$B2OF;E@$N0^EY(B
  double Ly;        //$B2OF;E@$N7PEY(B
  double Elev;         //$B2OF;E@$NI89b(B
  double width;     //$B2OF;I}(B

  int n_gX;  //$B<!$KFI$_9~$`2OF;E@$N%0%j%C%I$N(Bx$B:BI8(B    
  int n_gY;  //$B<!$KFI$_9~$`2OF;E@$N%0%j%C%I$N(By$B:BI8(B 
  int n_EPNo;    //$B<!$KFI$_9~$`2OF;E@$NC<E@HV9f(B
  int n_SegNo;   //$B<!$KFI$_9~$`2OF;E@$N2OF;6hJ,HV9f(B
  int n_EPinfo;  //$B<!$KFI$_9~$`2OF;E@$NC<E@>pJs(B
  double n_Lx;   //$B<!$KFI$_9~$`2OF;E@$N0^EY(B
  double n_Ly;   //$B<!$KFI$_9~$`2OF;E@$N7PEY(B
  double n_Elev; //$B<!$KFI$_9~$`2OF;E@$NI89b(B   
  double n_width;  //$B<!$KFI$_9~$`2OF;E@$N2OF;I}(B

  double mid_Lx[a];  //Lx$B!$(Bn_Lx $B$NCfE@(B
  double mid_Ly[a];  //Ly$B!$(Bn_Ly $B$NCfE@(B
  double mid_Elev[a];   //Elev$B!$(Bn_Elev$B$NCfE@(B
  double mid_width[a]; //$B@nI}$NJ?6Q(B

  int m;  //for $B%k!<%W$GMQ$$$kJQ?t(B

  while(fgets(buf, 256, fp_org_pf2) != NULL){
	if((sscanf(buf,"%d %d %d %d %d %lf %lf %lf %lf", 
		&gX, &gY, &EPNo, &SegNo, &EPinfo, &Lx, &Ly, &Elev, &width)) != 9){
		printf("cannot scan DATA!\n");
	}
	printf("%s\n",buf);

	int flag_hit = 0;  //$BFI$_9~$s$@2OF;E@$,!"@ZCG$9$Y$-2OF;6hJ,(B
					   //$B$+$I$&$+$r3P$($F$*$/$?$a$NJQ?t(B

	for(m = 0; m < a; m++){

    //$B@ZCG$7%G!<%?$r=$@5$9$Y$-2OF;6hJ,$J$i$P(B flag_hit $B$r#1$K$7$F$*(B
    //$B$-!"Ev3:2OF;6hJ,$K?7$?$JC<E@$rA^F~$9$k(B

	  if((link_cut[m] == SegNo) || (link_cut[m] == -SegNo)){
		  flag_hit = 1;
		  fgets(buf, 256, fp_org_pf2);
		  if((sscanf(buf,"%d %d %d %d %d %lf %lf %lf %lf",
				   &n_gX, &n_gY, &n_EPNo, &n_SegNo,
				   &n_EPinfo, &n_Lx, &n_Ly, &n_Elev,
				   &n_width)) != 9){
				printf("cannot scan next DATA!\n");
          }

		  printf("----------%d--------\n",link_cut[m]);
		  printf("---%d %d--\n",n_EPNo, n_SegNo);

		  mid_Lx[m] = (Lx + n_Lx)/2;
		  mid_Ly[m] = (Ly + n_Ly)/2;
		  mid_Elev[m] = (Elev + n_Elev)/2;
		  mid_width[m] = (width + n_width)/2;

		  fprintf(fp_work,"%d %d %d %d %d %lf %lf %lf %lf \n", 
                    gX, gY, EPNo, (num_RivSeg+m+1), EPinfo, Lx,
					Ly, Elev, width);

          //$B2OF;%G!<%?>e$G!"Ev3:2OF;6hJ,$,!">eN.$+$i2<N.J}8~$K5-$5$l$F$$$k(B
          //$B$+!"$=$N5U$+$G!"=$@5%G!<%?$N=q$-J}$rJQ$($kI,MW$,$"$k!#(B
			  
		  if(EPNo > 0){
              fprintf(fp_work,"%d %d %d %d 9 %lf %lf %lf %lf \n", 
                    gX, gY, -(num_EP+2*m+1), (num_RivSeg+m+1),
					mid_Lx[m], mid_Ly[m], mid_Elev[m], mid_width[m]);

              fprintf(fp_work,"%d %d %d %d 9 %lf %lf %lf %lf \n", 
                      gX, gY, (num_EP+2*m+2), SegNo, mid_Lx[m], 
		              mid_Ly[m], mid_Elev[m], mid_width[m]);

              fprintf(fp_work,"%d %d %d %d %d %lf %lf %lf %lf \n", 
                    n_gX, n_gY, n_EPNo, n_SegNo, n_EPinfo,
					n_Lx, n_Ly, n_Elev, n_width);

			  fprintf(fp_gcnd, "%d %d %d %d %d %d %d %d \n",
					  gX, gY, (num_EP+2*m+2), SegNo, gX, gY, 
					  (num_EP+2*m+1), (num_RivSeg+m+1));
		  }

		  if(EPNo < 0){
              fprintf(fp_work,"%d %d %d %d 9 %lf %lf %lf %lf \n", 
                    gX, gY, (num_EP+2*m+1), (num_RivSeg+m+1), 
					mid_Lx[m], mid_Ly[m], mid_Elev[m], mid_width[m]);

              fprintf(fp_work,"%d %d %d %d 9 %lf %lf %lf %lf \n", 
                      gX, gY, -(num_EP+2*m+2), SegNo, mid_Lx[m], 
		              mid_Ly[m], mid_Elev[m], mid_width[m]);

              fprintf(fp_work,"%d %d %d %d %d %lf %lf %lf %lf \n", 
                    n_gX, n_gY, n_EPNo, n_SegNo, n_EPinfo,
					n_Lx, n_Ly, n_Elev, n_width);

			  fprintf(fp_gcnd, "%d %d %d %d %d %d %d %d \n",
					  gX, gY, (num_EP+2*m+1), (num_RivSeg+m+1), gX, gY, 
					  (num_EP+2*m+2), SegNo);
		  }


          //$BEv3:2OF;6hJ,Fb$N2OF;E@$G$"$C$F$b!"=$@52U=j0J30$O=q$-49$($kI,MW(B
          //$B$,$J$$$N$G!"$=$N$^$^=q$+$;$k!#(B

		  fpos_t pos;
		  fgetpos(fp_org_pf2, &pos);

		  while(fgets(buf, 256, fp_org_pf2) != NULL){
			  if (buf[0] == '\n') continue;
              sscanf(buf,"%d %d %d %d %d %lf %lf %lf %lf", 
		             &gX, &gY, &EPNo, &SegNo, &EPinfo, &Lx, &Ly, 
					 &Elev, &width);
			  if((link_cut[m] == SegNo) || (link_cut[m] == -SegNo)){
				fgetpos(fp_org_pf2, &pos);
				fprintf(fp_work,"%d %d %d %d %d %lf %lf %lf %lf \n", 
                        gX, gY, EPNo, SegNo, 
						EPinfo,Lx, Ly, Elev, width);
			  }
			  else{ 
				fsetpos(fp_org_pf2, &pos);
			    goto FORLOOP_END;
			  }
		  }
	    } 
    }

    FORLOOP_END:;
    if(flag_hit == 0){
		fprintf(fp_work,"%d %d %d %d %d %lf %lf %lf %lf\n", 
				gX, gY, EPNo, SegNo, EPinfo, Lx, Ly, Elev, width);
	}
  }

  fclose(fp_work);

  //workfile $B$K=PNO$5$l$?%G!<%?$O!"(B[Data of End Point]$B$K?7$?$JC<E@(B
  //$B$N>pJs$rIU2C$7$F$$$J$$$N$G!"IU2C$7$?$b$N$r(B mod_pf2_fname $B$K=P(B
  //$BNO$9$k!#(B

  if((fp_work = fopen("workfile", "r")) == NULL){
    printf("Cannot open workfile.\n");
    exit(1);
  }

  if((fp_mod_pf2 = fopen(mod_pf2_fname, "w")) == NULL){
    printf("Cannot open modified pf2 file.\n");
    exit(1);
  }

  while (fgets(buf, 256, fp_work) != NULL){
	if (strncmp(buf, "[Number of River Segments]", 20) != 0){
	  fprintf(fp_mod_pf2,"%s",buf);
    }
	else{
		for(m = 0; m < a; m++){
		fprintf(fp_mod_pf2,"%d %lf %lf %lf 9\n",(num_EP+2*m+1),
				mid_Lx[m], mid_Ly[m], mid_Elev[m]);

		fprintf(fp_mod_pf2,"%d %lf %lf %lf 9\n",(num_EP+2*m+2),
				mid_Lx[m], mid_Ly[m], mid_Elev[m]);
		}
		fprintf(fp_mod_pf2,"%s",buf);
		//break;
	}

  }


}
