/*
solveObjLoop2.cc
-------------------------------------------

$B860x%*%V%8%'%/%H$,B0$9$k%0%j%C%I$N2OF;%G!<%?%U%!%$%k$r=q$-49$($k(B
$B%W%m%0%i%`!#%0%j%C%IFb$N2OF;LV$r9=@.$9$k2OF;6hJ,$N$&$A$G>eN.B&C<(B
$BE@$,J,N.E@$G$"$j!"$+$D2<N.B&C<E@$,9gN.E@$G$"$k2OF;6hJ,$rA4$F@ZCG(B
$B$9$k!#$^$?!"@ZCG$KH<$$%0%j%C%I4V@\B3>u67%U%!%$%k$K>pJs$rIU2C$9$k!#(B

-------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char** argv)
{
	// $B0z?t$N?t$N%A%'%C%/(B

	if (argc != 1 && argc != 5) {
    	printf("Usage : solveObjLoop pf2FileName");
		printf(" subsystemFileName mod_pf2_fname gcnd_connectFileName\n");
    	exit(1);
  	}

  	char org_pf2_fname[256];      // $B$b$H$N2OF;%G!<%?%U%!%$%kL>(B
  	char sub_fname[256];          // $BItJ,7O%b%G%k$N2OF;6hJ,@\B3>pJs%U%!%$%kL>(B
  	char mod_pf2_fname[256];      // $B=$@5$5$l$?2OF;%G!<%?%U%!%$%kL>(B
  	char gcnd_fname[256];		  // $B%0%j%C%I4V@\B3>u67%U%!%$%kL>(B
								

  	if (argc == 1) {
    	printf("# original pf2 file : ");
    	scanf("%s", org_pf2_fname);
    	printf("# link connection file : ");
    	scanf("%s", sub_fname);
		printf("# modified pf2 file : ");
		scanf("%s", mod_pf2_fname);
		printf("# gcnd connection file : ");
		scanf("%s", gcnd_fname);
  	}

  	else {
    	sscanf(argv[1], "%s", org_pf2_fname);
    	sscanf(argv[2], "%s", sub_fname);
    	sscanf(argv[3], "%s", mod_pf2_fname);
    	sscanf(argv[4], "%s", gcnd_fname);
  	}

  	FILE* fp_org_pf2;     // $BEv3:%0%j%C%I$N2OF;%G!<%?%U%!%$%k(B
  	FILE* fp_sub;        // $BItJ,7O%b%G%k$N2OF;6hJ,@\B3>pJs%U%!%$%k(B
  	FILE* fp_mod_pf2;    // $B=$@5$5$l$?ItJ,?e7O$N2OF;%G!<%?%U%!%$%k(B
  	FILE* fp_gcnd;       // $B%0%j%C%I4V@\B3>u67%U%!%$%k(B
	FILE* fp_work;

	char buf[256];
  	char* pbuf;
  	int seg_no, sigma_up, mu_up, sigma_down, mu_down;

  	//$BItJ,?e7O$4$H$N2OF;6hJ,@\B3>u67%U%!%$%k(B(**.sub)$B$+$i@ZCG$9$Y$-2O(B
  	//$BF;6hJ,$NHV9f$rFI$_$H$k!#(B 

	if((fp_sub = fopen(sub_fname, "r")) == NULL){
    	printf("Cannot open link connection file.\n");
    	exit(1);
  	}

	int link_cut[100];   //$B@ZCG$9$Y$-2OF;6hJ,HV9f$rF~$l$F$*$/G[Ns(B
	int a = 0;
	int j, k;
  	while(fgets(buf, 256, fp_sub) != NULL){
    	pbuf = buf;
		if((buf[0] == '#') || (buf[0] == '\n')) continue;
		if(sscanf(pbuf, "%d", &seg_no) != 1){
			printf("Cannot scan seg_no.\n");
			exit(1);
    	}
		while(*pbuf != ':') pbuf++;
	  	pbuf++;
		int flag_bunryuu = 0;
	  	int flag_gouryuu = 0;
	
	  	if(sscanf(pbuf, "%d", &sigma_up) != 1){
        	printf("Cannot scan sigma_up.\n");
			exit(1);
	  	}
	  	//printf("sigma_up= %d\n", sigma_up);
	  	if(sigma_up < 2) continue;
		else{
        	while(*pbuf != ':') pbuf++;
			pbuf++;
			for(j = 0; j < sigma_up; j++){
		  		while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
	      		if(sscanf(pbuf, "%d", &mu_up) != 1){
					printf("Cannot scan mu_up.\n");
					exit(1);
				}
				//printf("mu_up= %d\n", mu_up);
		  		while((*pbuf != ' ') && (*pbuf != '\t')) pbuf++; 
		  		if(mu_up < 0){
		    		// $B>eN.B&$KJ,N.E@$rH/8+(B
					flag_bunryuu = 1;
					break;
				}
			}
			while(*pbuf != ':') pbuf++;
			pbuf++;
			
			if(sscanf(pbuf, "%d", &sigma_down) != 1){
				printf("Cannot scan sigma_down.\n");
				exit(1);
			}
			if(sigma_down == 1){
				//$B>eN.B&C<E@$,J,N.E@!"2<N.B&C<E@$,(B
				//$B9gN.E@$G$"$k2OF;6hJ,$N0lIt$G$"$k2DG=@-$,$"(B
				//$B$k$N$G8uJd$H$7$F;D$7$F$*$/I,MW$,$"$k!#(B
		  		flag_gouryuu = 1;
			}
        	else{
		  		while(*pbuf != ':') pbuf++;
		  		pbuf++;
	  	  		for(k = 0; k < sigma_down; k++){
            		while((*pbuf == ' ') || (*pbuf == '\t')) pbuf++;
	    			if(sscanf(pbuf, "%d", &mu_down) != 1){
			  			printf("Cannot scan mu_down.\n");
						exit(1);
					}
					while((*pbuf != ' ') && (*pbuf != '\t')) pbuf++;
	  				if(mu_down > 0){
	      	  		// $B2<N.B&$K9gN.E@$rH/8+!#(B
						flag_gouryuu = 1;
						break;
					}
				}
			}
		}
	  	if((flag_bunryuu == 1) && (flag_gouryuu == 1)){
			link_cut[a] = seg_no;
			a = a+1;
		}
	}
	fclose(fp_sub);

  	//$B0J>e$G@ZCG$9$Y$-2OF;6hJ,HV9f$rFI$_$H$C$?!#(B
  	//$B0J2<$G$O3F%*%V%8%'%/%H$K$*$$$F@ZCG$9$Y$-2OF;6hJ,$r!"2OF;%G!<%?>e(B
  	//$B$G@ZCG$9$k:n6H!"$*$h$S(B gcnd $B$,=PNO$7$?%0%j%C%I4V$N@\B3>u67%U%!(B
  	//$B%$%k$K?7$?$J@\B3>pJs$r2C$($k:n6H$r9T$J$&!#(B

  	int num_EP;      //$BC<E@$N8D?t(B
  	int num_RivSeg;  //$B2OF;6hJ,$N8D?t(B

  	int gX;      //$B%0%j%C%I$N(Bx$B:BI8(B
  	int gY;      //$B%0%j%C%I$N(By$B:BI8(B
  	int EPNo;         //$BC<E@HV9f(B
  	int SegNo;   //$B2OF;6hJ,HV9f(B
  	int EPinfo;       //$BC<E@>pJs(B
  	double Lx;        //$B2OF;E@$N0^EY(B
  	double Ly;        //$B2OF;E@$N7PEY(B
  	double Elev;      //$B2OF;E@$NI89b(B
  	double width;     //$B2OF;I}(B

	int n_EPNo;    //$B<!$KFI$_9~$`2OF;E@$NC<E@HV9f(B
  	int n_SegNo;   //$B<!$KFI$_9~$`2OF;E@$N2OF;6hJ,HV9f(B
  	int n_EPinfo;  //$B<!$KFI$_9~$`2OF;E@$NC<E@>pJs(B
  	double n_Lx;   //$B<!$KFI$_9~$`2OF;E@$N0^EY(B
  	double n_Ly;   //$B<!$KFI$_9~$`2OF;E@$N7PEY(B
  	double n_Elev; //$B<!$KFI$_9~$`2OF;E@$NI89b(B   
  	double n_width;  //$B<!$KFI$_9~$`2OF;E@$N2OF;I}(B

  	double mid_Lx[a];  //Lx$B!$(Bn_Lx $B$NCfE@(B
  	double mid_Ly[a];  //Ly$B!$(Bn_Ly $B$NCfE@(B
  	double mid_Elev[a];   //Elev$B!$(Bn_Elev$B$NCfE@(B
  	double mid_width[a]; //$B@nI}$NJ?6Q(B

	int flagD[a];
	int numRP[a]; //$B@ZCG$9$Y$-2OF;6hJ,Fb$KB8:_$9$k2OF;E@$N8D?t$r3JG<$9$kG[Ns(B
	int newSegNo[a]; //$B@ZCG$K$h$j@8$8$k?7$?$J2OF;6hJ,$NHV9f$r3JG<$9$kG[Ns(B 
	int** bEPiNo; //$B@ZCG$9$Y$-2OF;6hJ,$KA^F~$9$kC<E@$NC<E@HV9f$r3JG<$9$kG[Ns(B 

	bEPiNo = new int*[a];
	for(j = 0; j < a; j++){
		bEPiNo[j] = new int[2];
		flagD[j] = 0;
		numRP[j] = 0;
		newSegNo[j] = 0;
	}
	for(j = 0; j < a; j++){
		for(k = 0; k < 2; k++){
			bEPiNo[j][k] == 0;
		}
	}

  	if((fp_org_pf2 = fopen(org_pf2_fname, "r")) == NULL){
    	printf("Cannot open original pf2 file.\n");
    	exit(1);
  	}
  	while (fgets(buf, 256, fp_org_pf2) != NULL){
		if (strncmp(buf, "[Number of End Points]", 20) == 0){
			fgets(buf, 256, fp_org_pf2);
			if(sscanf(buf, "%d", &num_EP) != 1){
				printf("cannot scan num_EP\n");
				exit(1);
			}
    	}
		if (strncmp(buf, "[Number of River Segments]", 20) == 0){
			fgets(buf, 256, fp_org_pf2);
			if(sscanf(buf, "%d", &num_RivSeg) != 1){
				printf("cannot scan num_RivSeg\n");
				exit(1);
			}
		}
		if(sscanf(buf, "%d %d %d %d %d %lf %lf %lf %lf", &gX,
				  &gY, &EPNo, &SegNo, &EPinfo, &Lx, &Ly, &Elev,
				  &width) == 9){
			if(EPNo == 0) continue;
			for(j = 0; j < a; j++){
				if((SegNo == link_cut[j])&&(flagD[j] == 0)){
					flagD[j] = 1;
					bEPiNo[j][0] = num_EP + 2*j + 1;
					bEPiNo[j][1] = num_EP + 2*j + 2;
					newSegNo[j] = num_RivSeg + j + 1;
					fgets(buf, 256, fp_org_pf2);
					sscanf(buf, "%d %d %d %d %d %lf %lf %lf %lf", 
                     	   &gX, &gY, &n_EPNo, &n_SegNo,
						   &n_EPinfo, &n_Lx, &n_Ly, &n_Elev,&n_width);
				    if(SegNo != n_SegNo){
						printf("data is wrong!\n");
						exit(1);
					}
					mid_Lx[j] = (Lx + n_Lx)/2;
					mid_Ly[j] = (Ly + n_Ly)/2;
					mid_Elev[j] = (Elev + n_Elev)/2;
					mid_width[j] = (width + n_width)/2;
					break;
				}
			}
		}
	}
	fclose(fp_org_pf2);

//----------numRP[a]$B$KCM$r3JG<$9$k!#(B-----------
	if((fp_org_pf2 = fopen(org_pf2_fname, "r")) == NULL){
    	printf("Cannot open original pf2 file.\n");
    	exit(1);
  	}
	while(fgets(buf, 256, fp_org_pf2) != NULL){
		if(sscanf(buf, "%d %d %d %d %d %lf %lf %lf %lf", &gX,
				  &gY, &EPNo, &SegNo, &EPinfo, &Lx, &Ly, &Elev,
				  &width) != 9) continue;
		for(j = 0; j < a; j++){
			if(SegNo == link_cut[j]){
				numRP[j] = numRP[j] + 1;
				break;
			}
		}
	}
	fclose(fp_org_pf2);

//--------[Data]$B$h$j>e$r=q$/(B-------------------------------------
  	if((fp_org_pf2 = fopen(org_pf2_fname, "r")) == NULL){
    	printf("Cannot open original pf2 file.\n");
    	exit(1);
  	}
  	if((fp_mod_pf2 = fopen(mod_pf2_fname, "w")) == NULL){
    	printf("Cannot open modified pf2 file.\n");
    	exit(1);
  	}
	while(fgets(buf, 256, fp_org_pf2) != NULL){
		if (strncmp(buf, "[Number of End Points]", 18) != 0){
	  		fprintf(fp_mod_pf2, "%s", buf);
    	}
		else{
			fprintf(fp_mod_pf2, "%s", buf);
			fprintf(fp_mod_pf2,"%d\n",(num_EP + 2*a));
			fgets(buf, 256, fp_org_pf2);
			break;
		}
	}
	while(fgets(buf, 256, fp_org_pf2) != NULL){
		if (strncmp(buf, "[Number of River Segments]", 25) != 0){
			fprintf(fp_mod_pf2, "%s", buf);
		}
		else{
			for(j = 0; j < a; j++){
				fprintf(fp_mod_pf2,"%d %lf %lf %lf 9\n",
					    bEPiNo[j][0],mid_Lx[j], mid_Ly[j],
						mid_Elev[j]);
				fprintf(fp_mod_pf2,"%d %lf %lf %lf 9\n",
					    bEPiNo[j][1],mid_Lx[j], mid_Ly[j],
						mid_Elev[j]);
			}
			fprintf(fp_mod_pf2,"%s",buf);
			fprintf(fp_mod_pf2, "%d\n", (num_RivSeg + a));
			fprintf(fp_mod_pf2,"[Data]\n");
			fgets(buf, 256, fp_org_pf2);
			fgets(buf, 256, fp_org_pf2);
			break;
		}
	}
//-------------$B@ZCG$9$k2OF;6hJ,Fb$N2OF;E@$N>pJs$rG[Ns$K3JG<$9$k(B-----
//-------------$B@ZCG$7$J$$2OF;6hJ,$N%G!<%?$O$=$N$^$^=q$/(B------------
	int **bEPNo, **bEPinfo;
	double **bLx, **bLy, **bElev;

	bEPNo = new int*[a];
	bEPinfo = new int*[a];
	bLx = new double*[a];
	bLy = new double*[a];
	bElev = new double*[a];
	int n[a];

	for(j = 0; j < a; j++){
		bEPNo[j] = new int[numRP[j]];
		bEPinfo[j] = new int[numRP[j]];
		bLx[j] = new double[numRP[j]];
		bLy[j] = new double[numRP[j]];
		bElev[j] = new double[numRP[j]];
		n[j] = 0;
	}
	for(j = 0; j < a; j++){
		for(k = 0; k < numRP[j]; k++){
			bEPNo[j][k] == 0;
			bEPinfo[j][k] == 0;
			bLx[j][k] == 0;
			bLy[j][k] == 0;
			bElev[j][k] == 0;
		}
	}
	int flagCR;
	while (fgets(buf, 256, fp_org_pf2) != NULL){
		if(sscanf(buf, "%d %d %d %d %d %lf %lf %lf %lf", &gX,
				  &gY, &EPNo, &SegNo, &EPinfo, &Lx, &Ly, &Elev,
				  &width) != 9){
			printf("Data is wrong 2!\n");
			exit(1);
		}
		flagCR = 0;
		for(j = 0; j < a; j++){
			if(SegNo == link_cut[j]){
				bEPNo[j][n[j]] = EPNo;
				bEPinfo[j][n[j]] = EPinfo;
				bLx[j][n[j]] = Lx;
				bLy[j][n[j]] = Ly;
				bElev[j][n[j]] = Elev;
				n[j] = n[j] + 1;
				flagCR = 1;
				break;
			}
		}
		if(flagCR == 0){
			fprintf(fp_mod_pf2, "%s", buf);
		}
	}
	fclose(fp_org_pf2);
	fclose(fp_mod_pf2);

//--------------------------------------------------
  	if((fp_mod_pf2 = fopen(mod_pf2_fname, "a")) == NULL){
    	printf("Cannot open modified pf2 file.\n");
    	exit(1);
  	}
  	if((fp_gcnd = fopen(gcnd_fname, "a")) == NULL){
    	printf("Cannot open modified gcnd-connect file.\n");
    	exit(1);
  	}
	for(j = 0; j < a; j++){
		if(bEPNo[j][0] > 0){
			fprintf(fp_mod_pf2,"%d %d %d %d %d %lf %lf %lf %lf\n",
					gX,	gY, bEPNo[j][0], link_cut[j], bEPinfo[j][0], 
					bLx[j][0], bLy[j][0], bElev[j][0]);
			fprintf(fp_mod_pf2,"%d %d %d %d 9 %lf %lf %lf %lf\n",
					gX,	gY, -(bEPiNo[j][0]), link_cut[j], mid_Lx[j],
					mid_Ly[j], mid_Elev[j], mid_width[j]);
			fprintf(fp_mod_pf2,"%d %d %d %d 9 %lf %lf %lf %lf\n",
					gX,	gY, bEPiNo[j][1], newSegNo[j], mid_Lx[j],
					mid_Ly[j], mid_Elev[j], mid_width[j]);
			for(k = 1; k < (numRP[j]); k++){
				fprintf(fp_mod_pf2,"%d %d %d %d %d %lf %lf %lf %lf\n",
						gX,	gY, bEPNo[j][k], newSegNo[j], bEPinfo[j][k], 
						bLx[j][k], bLy[j][k], bElev[j][k]);
			}
			fprintf(fp_gcnd, "%d %d %d %d %d %d %d %d\n", gX,
					gY, bEPiNo[j][1], newSegNo[j], gX, gY,
					bEPiNo[j][0], link_cut[j]);
		}
		else{
			fprintf(fp_mod_pf2,"%d %d %d %d %d %lf %lf %lf %lf\n",
					gX,	gY, bEPNo[j][0], newSegNo[j], bEPinfo[j][0], 
					bLx[j][0], bLy[j][0], bElev[j][0]);
			fprintf(fp_mod_pf2,"%d %d %d %d 9 %lf %lf %lf %lf\n",
					gX,	gY, bEPiNo[j][0], newSegNo[j], mid_Lx[j],
					mid_Ly[j], mid_Elev[j], mid_width[j]);
			fprintf(fp_mod_pf2,"%d %d %d %d 9 %lf %lf %lf %lf\n",
					gX,	gY, -(bEPiNo[j][1]), link_cut[j], mid_Lx[j],
					mid_Ly[j], mid_Elev[j], mid_width[j]);
			for(k = 1; k < (numRP[j]); k++){
				fprintf(fp_mod_pf2,"%d %d %d %d %d %lf %lf %lf %lf\n",
						gX,	gY, bEPNo[j][k], link_cut[j], bEPinfo[j][k], 
						bLx[j][k], bLy[j][k], bElev[j][k]);
			}
			fprintf(fp_gcnd, "%d %d %d %d %d %d %d %d\n", gX,
					gY, bEPiNo[j][0], newSegNo[j], gX,
					gY,bEPiNo[j][1], link_cut[j]);
		}
	}
	fclose(fp_gcnd);
	fclose(fp_mod_pf2);
}



